//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PStorageParent_h
#define PStorageParent_h

#include "mozilla/dom/PStorage.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class PStorageParent :
    public mozilla::ipc::IProtocol
{
    friend class mozilla::dom::PContentParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;

    typedef PStorage::State State;

    virtual bool
    Recv__delete__();
    virtual bool
    RecvPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const uint32_t& alreadyLoadedCount,
            nsTArray<nsString>* keys,
            nsTArray<nsString>* values,
            nsresult* rv) = 0;
    virtual bool
    RecvAsyncPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const bool& priority) = 0;
    virtual bool
    RecvAsyncGetUsage(const nsCString& scope) = 0;
    virtual bool
    RecvAsyncAddItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value) = 0;
    virtual bool
    RecvAsyncUpdateItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value) = 0;
    virtual bool
    RecvAsyncRemoveItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key) = 0;
    virtual bool
    RecvAsyncClear(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix) = 0;
    virtual bool
    RecvAsyncFlush() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PStorageParent();

    virtual ~PStorageParent();

    PContentParent*
    Manager() const;

    PStorage::State
    state();

    MOZ_MUST_USE bool
    SendObserve(
            const nsCString& topic,
            const nsString& originAttributesPattern,
            const nsCString& originScope);

    MOZ_MUST_USE bool
    SendOriginsHavingData(const nsTArray<nsCString>& origins);

    MOZ_MUST_USE bool
    SendLoadItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value);

    MOZ_MUST_USE bool
    SendLoadDone(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsresult& rv);

    MOZ_MUST_USE bool
    SendLoadUsage(
            const nsCString& scope,
            const int64_t& usage);

    MOZ_MUST_USE bool
    SendError(const nsresult& rv);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PStorageParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PStorageParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class StorageParent :
    public PStorageParent
{
    virtual bool
    RecvPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const uint32_t& alreadyLoadedCount,
            nsTArray<nsString>* keys,
            nsTArray<nsString>* values,
            nsresult* rv);

    virtual bool
    RecvAsyncPreload(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const bool& priority);

    virtual bool
    RecvAsyncGetUsage(const nsCString& scope);

    virtual bool
    RecvAsyncAddItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value);

    virtual bool
    RecvAsyncUpdateItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key,
            const nsString& value);

    virtual bool
    RecvAsyncRemoveItem(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix,
            const nsString& key);

    virtual bool
    RecvAsyncClear(
            const nsCString& originSuffix,
            const nsCString& originNoSuffix);

    virtual bool
    RecvAsyncFlush();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT StorageParent();
    virtual ~StorageParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
bool
StorageParent::RecvPreload(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const uint32_t& alreadyLoadedCount,
        nsTArray<nsString>* keys,
        nsTArray<nsString>* values,
        nsresult* rv)
{
    return false;
}

bool
StorageParent::RecvAsyncPreload(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const bool& priority)
{
    return false;
}

bool
StorageParent::RecvAsyncGetUsage(const nsCString& scope)
{
    return false;
}

bool
StorageParent::RecvAsyncAddItem(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const nsString& key,
        const nsString& value)
{
    return false;
}

bool
StorageParent::RecvAsyncUpdateItem(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const nsString& key,
        const nsString& value)
{
    return false;
}

bool
StorageParent::RecvAsyncRemoveItem(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const nsString& key)
{
    return false;
}

bool
StorageParent::RecvAsyncClear(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix)
{
    return false;
}

bool
StorageParent::RecvAsyncFlush()
{
    return false;
}

void
StorageParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT StorageParent::StorageParent()
{
    MOZ_COUNT_CTOR(StorageParent);
}

MOZ_IMPLICIT StorageParent::~StorageParent()
{
    MOZ_COUNT_DTOR(StorageParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PStorageParent_h
