//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PRemotePrintJobParent_h
#define PRemotePrintJobParent_h

#include "mozilla/layout/PRemotePrintJob.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace embedding {
class PPrintingParent;
} // namespace embedding
} // namespace mozilla
namespace mozilla {
namespace embedding {
class PPrintingChild;
} // namespace embedding
} // namespace mozilla

namespace mozilla {
namespace embedding {
class PPrintingParent;
} // namespace embedding
} // namespace mozilla

namespace mozilla {
namespace embedding {
class PPrintSettingsDialogParent;
} // namespace embedding
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace layout {


class PRemotePrintJobParent :
    public mozilla::ipc::IProtocol
{
    friend class mozilla::embedding::PPrintingParent;

    friend class mozilla::embedding::PPrintSettingsDialogParent;

    friend class mozilla::dom::PBrowserParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::embedding::PPrintingParent PPrintingParent;
    typedef mozilla::embedding::PPrintingChild PPrintingChild;

    typedef PRemotePrintJob::State State;

    virtual bool
    RecvAbortPrint(const nsresult& aRv) = 0;
    virtual bool
    RecvInitializePrint(
            const nsString& aDocumentTitle,
            const nsString& aPrintToFile,
            const int32_t& aStartPage,
            const int32_t& aEndPage) = 0;
    virtual bool
    RecvProcessPage(const nsCString& aPageFileName) = 0;
    virtual bool
    RecvFinalizePrint() = 0;
    virtual bool
    RecvStateChange(
            const long& aStateFlags,
            const nsresult& aStatus) = 0;
    virtual bool
    RecvProgressChange(
            const long& aCurSelfProgress,
            const long& aMaxSelfProgress,
            const long& aCurTotalProgress,
            const long& aMaxTotalProgress) = 0;
    virtual bool
    RecvStatusChange(const nsresult& aStatus) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PRemotePrintJobParent();

    virtual ~PRemotePrintJobParent();

    PPrintingParent*
    Manager() const;

    PRemotePrintJob::State
    state();

    MOZ_MUST_USE bool
    SendAbortPrint(const nsresult& aRv);

    MOZ_MUST_USE bool
    SendPrintInitializationResult(const nsresult& aRv);

    MOZ_MUST_USE bool
    SendPageProcessed();

    MOZ_MUST_USE static bool
    Send__delete__(PRemotePrintJobParent* actor);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PRemotePrintJobParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PRemotePrintJobParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace layout
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace layout {
class RemotePrintJobParent :
    public PRemotePrintJobParent
{
    virtual bool
    RecvAbortPrint(const nsresult& aRv);

    virtual bool
    RecvInitializePrint(
            const nsString& aDocumentTitle,
            const nsString& aPrintToFile,
            const int32_t& aStartPage,
            const int32_t& aEndPage);

    virtual bool
    RecvProcessPage(const nsCString& aPageFileName);

    virtual bool
    RecvFinalizePrint();

    virtual bool
    RecvStateChange(
            const long& aStateFlags,
            const nsresult& aStatus);

    virtual bool
    RecvProgressChange(
            const long& aCurSelfProgress,
            const long& aMaxSelfProgress,
            const long& aCurTotalProgress,
            const long& aMaxTotalProgress);

    virtual bool
    RecvStatusChange(const nsresult& aStatus);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT RemotePrintJobParent();
    virtual ~RemotePrintJobParent();
};
} // namespace layout
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace layout {
bool
RemotePrintJobParent::RecvAbortPrint(const nsresult& aRv)
{
    return false;
}

bool
RemotePrintJobParent::RecvInitializePrint(
        const nsString& aDocumentTitle,
        const nsString& aPrintToFile,
        const int32_t& aStartPage,
        const int32_t& aEndPage)
{
    return false;
}

bool
RemotePrintJobParent::RecvProcessPage(const nsCString& aPageFileName)
{
    return false;
}

bool
RemotePrintJobParent::RecvFinalizePrint()
{
    return false;
}

bool
RemotePrintJobParent::RecvStateChange(
        const long& aStateFlags,
        const nsresult& aStatus)
{
    return false;
}

bool
RemotePrintJobParent::RecvProgressChange(
        const long& aCurSelfProgress,
        const long& aMaxSelfProgress,
        const long& aCurTotalProgress,
        const long& aMaxTotalProgress)
{
    return false;
}

bool
RemotePrintJobParent::RecvStatusChange(const nsresult& aStatus)
{
    return false;
}

void
RemotePrintJobParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT RemotePrintJobParent::RemotePrintJobParent()
{
    MOZ_COUNT_CTOR(RemotePrintJobParent);
}

MOZ_IMPLICIT RemotePrintJobParent::~RemotePrintJobParent()
{
    MOZ_COUNT_DTOR(RemotePrintJobParent);
}

} // namespace layout
} // namespace mozilla
#endif // if 0

#endif // ifndef PRemotePrintJobParent_h
